



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Python标准库之urllib，urllib2</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Python标准库之urllib，urllib2</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-13 15:25:20 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>urllib模块提供了一些高级接口，用于编写需要与HTTP服务器交互的客户端。典型的应用程序包括从网页抓取数据、自动化、代理、网页爬虫等。</p>
<p>在Python 2中，urllib功能分散在几个不同的库模块中，包括urllib、urllib2、urlparse等。在Python 3中，所有功能都合并在urllib包中。</p>
<h3>1. urlopen<strong>(url[,&nbsp;data[,&nbsp;timeout]])&nbsp;</strong></h3>
<p>要抓取html网页，很简单</p>
<div>
<pre class="prettyprint linenums">import urllib2<br />
response=urllib2.urlopen('http://www.google.com')</pre>
</div>
<p>urlopen创建一个表示远程url的类文件对象，然后像本地文件一样操作这个类文件对象来获取远程数据。参数url表示远程数据的路径，一般是网址。如果要执行更加复杂的操作，如修改HTTP报头，可创建Request实例并当为url参数使用；参数data表示以post方式提交到url的数</p>
<p>据，需要经过URL编码；timeout是可选的超时选项。urlopen返回&nbsp;一个类文件对象，他提供了如下方法：</p>
<ul><li>read()&nbsp;,&nbsp;readline()&nbsp;,&nbsp;readlines()&nbsp;,&nbsp;fileno()&nbsp;,&nbsp;close()&nbsp;：这些方法的使用方式与文件对象完全一样</li>
<li>info()：返回一个<tt>mimetools.Message</tt>对象，表示远程服务器返回的头信息</li>
<li>getcode()：返回整数形式的HTTP响应码。例如：成功时返回200，未找到文件时返回404</li>
<li>geturl()：返回请求的实际url</li></ul>
<div>
<pre class="prettyprint linenums">&gt;&gt;&gt; response.getcode()<br />
200<br />
&gt;&gt;&gt; response.geturl()<br />
'http://www.google.com.hk/'</pre>
</div>
<p>　　info()返回的<tt>mimetools.Message映射</tt>对象有headers、getheader()、getplist() 、getparam()等方法。</p>
<div>
<pre class="prettyprint linenums">message=response.info()<br />
message.headers  #返回http报头信息的列表<br />
for header in message:<br />
    print header,message.getheader(header)  #获取报头信息<br />
for header in message:<br />
    print header,message[header]     #message可用字典的方法分析<br />
message.getparam('charset')  #获取url编码
</pre>
</div>
<h3>2. URL编码 urllib.urlencode()</h3>
<p>urllib中还提供了一些方法，用于对url进行编码、解码。url中是不能出现一些特殊的符号的，有些符号有特殊的用途。</p>
<p>urllib.quote()</p>
<p>使用适合URL内容的转义序列替换string中的特殊字符。字母、数字、下划线(_)、逗号(,)、句号(.)、连字符(-)都保持不变。其他字符转换成%xx形式的转义序列，默认使用utf-8编码。</p>
<p>urllib.unquote()</p>
<p>解码</p>
<p>urllib.urlencode(query)</p>
<p>将query中的查询值转换成一个URL编码的字符串。query可以是一个字典，也可以是一个(key,value)的对序列。得到的是以'&amp;'字符分割的'key=value'对序列。</p>
<div>
<pre class="prettyprint linenums">import urllib<br />
form_data={'user':'jhon','passwd':'123456'}  #要提交的表单数据<br />
url_data=urllib.urlencode(form_data)    #url_data被编码为'passwd=123456&amp;user=jhon'<br />
full_url='http://www.example.com'+'?'+url_data<br />
u=urllib2.urlopen(full_url)　</pre>
</div>
<h3>3. urllib2.Request(url [, data [, headers ]])</h3>
<p>Request实例可以替代urlopen（url）中的url来实现更加复杂的操作。headers是一个字典，包含了可表示HTTP报头内容的键值映射。</p>
<p>有一些网站不希望被某些程序浏览或者针对不同的浏览器返回不同的版本。默认情况下，urlib2把自己识别为Python-urllib/x.y（这里的 xy是python发行版的主要或次要的版本号，如，</p>
<p>Python-urllib/2.7）。浏览器区别自身的方式是通过User-Agent头。如果要模拟chrome浏览器连接：</p>
<div>
<pre class="prettyprint linenums">headers={'User-Agent':'Mozilla/5.0 (Windows NT 6.1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.102 Safari/537.36'}<br />
r=urllib2.Request("http://www.google.com",headers=headers)<br />
u=urllib2.urlopen(r)
</pre>
</div>
<p>要处理cookie的时候，注意不要在Request里面设置headers，因为cookie也在headers里面，设置headers会将cookie覆盖掉。</p>
<p>可以用Request().add_header(key,value)方法。</p>
<div>
<pre class="prettyprint linenums">import urllib2<br />
import cookielib<br />
cookie=cookielib.CookieJar()<br />
opener=urllib2.build_opener(urllib2.HTTPCookieProcessor(cookie))<br />
r=urllib2.Request('http://www.google.com')<br />
r.add_header('User-Agent','Mozilla/5.0 (Windows NT 6.1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.102 Safari/537.36')<br />
u=opener.open(r)
</pre>
</div>
<p>　　</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/m96mw2n8.html">web请求的拦截与处理</a>
		</li>
						<li><a href="https://www.batexi.com/a/r9335ln9.html">Lua字符串库&lpar;整理&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/m96en7jq.html">兼容IE与firefox的css 线性渐变（linear-gradient）</a>
		</li>
						<li><a href="https://www.batexi.com/a/96oopzj9.html">python&lowbar;way day18 html-day4， Django路由，（正则匹配页码，包含自开发分页功能）， 模板，  Model&lpar;jDango-ORM&rpar; &colon; SQLite，数据库时间字段插入的方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/8okv4x59.html">&lbrack;Everyday Mathematic&rsqb;20150217</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1z44349.html">Android JNI之C&sol;C&plus;&plus;层调用JAVA</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k12x759.html">Linux用户及用户组设置</a>
		</li>
						<li><a href="https://www.batexi.com/a/8okxjvl9.html">VC中利用多线程技术实现线程之间的通信</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rdjnjd8.html">hdu-5082</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1kz1m09.html">Ubuntu 使用中的问题总结</a>
		</li>
						<li><a href="https://www.batexi.com/a/8eyywee9.html">chrome 关闭自己主动更新</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kppdm79.html">怎么将Emeditor设置成网页查看源代码的默认编译器</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4znrxj9.html">服务器上的Git</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7z2pp19.html">Python单元测试框架</a>
		</li>
						<li><a href="https://www.batexi.com/a/950yr2e8.html">React Native学习（二）&mdash;&mdash; 开始一个项目</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ey22pj9.html">python&lowbar;如何快速安装第三方库？</a>
		</li>
						<li><a href="https://www.batexi.com/a/9r56mkrq.html">关于ajax跨域的一些解决方案</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdjd1zxq.html">phantomjs在win10下的安装</a>
		</li>
						<li><a href="https://www.batexi.com/a/ql1dl769.html">【C&num;&sol;WPF】键盘事件</a>
		</li>
						<li><a href="https://www.batexi.com/a/ql1371e9.html">asp&period;net 初级程序员面试题【待续】</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qvv733jq.html">Fluent Validation For &period;NET</a>
			</li>
						<li><a href="https://www.batexi.com/a/qlmxp609.html">powerdesign设置实体显示格式</a>
			</li>
						<li><a href="https://www.batexi.com/a/9rdww5m8.html">利用wireshark抓取Telnet的用户名和密码</a>
			</li>
						<li><a href="https://www.batexi.com/a/8k1dd559.html">启用Win8&lpar;中文版&sol;核心版&rpar;中被阉割的远程桌面服务端</a>
			</li>
						<li><a href="https://www.batexi.com/a/qlmx7dx9.html">vJine&period;Core 0&period;3&period;0&period;49 正式发布</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4y62kjq.html">css 控制滚动样式</a>
			</li>
						<li><a href="https://www.batexi.com/a/8mnxv1rq.html">CSU-ACM2016暑期集训训练4-BFS（F - Oil Deposits）</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pjv6gz9.html">java三线程循环有序打印ABC</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2w6ln3q.html">Oracle笔记1</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2w6ze3q.html">mac下如何查看指定端口被谁占用并且杀死该进程</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
